%{
#include <stdio.h>
#include <stdlib.h>

#include "calc.tab.h"
#include "dict.h"

void yyerror(char* msg);
extern int yylex();
%}

%union {
    char*   name;
    double  num;
}

%token <name> IDENT
%token <num> NUMBER
%token QUIT

%type <num> expr

%left '-' '+'
%left '*' '/'
%left NEG


%%

list:
    | list '\n'
    | list statement '\n'
    ;
    
statement: expr                                 { printf("%f\n", $1); }
    | IDENT '=' expr                          { insert($1, $3); }
    /* die naechste Regel dient nur der Anschauung */
    | NUMBER { printf("%f .. ", $1); } '#' NUMBER   { printf("%f\n", $4); }
    ;
    
expr: IDENT                     { $$ = lookup($1); }
    | NUMBER                    { $$ = $1; }
    | expr '+' expr             { $$ = $1 + $3; }
    | expr '-' expr             { $$ = $1 - $3; }
    | expr '*' expr             { $$ = $1 * $3; }
    | expr '/' expr             { $$ = $1 / $3; }
    | '-' expr %prec NEG        { $$ = -$2; }
    | '(' expr ')'              { $$ = $2; }
    | QUIT                      { printf("leaving ...\n"); exit(0); }
    ;

%%

int main(int c, char** v) {
    yydebug = c-1;
    return yyparse();
}

void yyerror(char* msg) {
    fprintf(stderr, "ERROR: %s\n", msg);
    exit(-1);
}
