%{
#include <stdio.h>
void yyerror(char*);
int yylex();
%}

%%

machines: machine | machines machine;

machine: name '\n'  {puts("This might be a machine!");};

name:
	commodore power2
	| playstation number
	| kleincomputer year
	;

commodore: 'C';
playstation: 'P' 'S';
kleincomputer: 'K' 'C';
power2: '1' '6' | '3' '2' | '6' '4' | '1' '2' '8';
number: '1' | '2' | '3' | '4';
year: '8' yearminor;
yearminor: '5' | '6' | '7';

%%

int yylex() {
	char c = getchar();
	return c==EOF ? 0 : c; 
}

int main() { return yyparse(); }

void yyerror(char* s) {
	fprintf(stderr, "%s\n", s);
}
